image: docker:latest

services:
  - docker:dind 

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

stages:
  - build
  - docs
  - test

build-doxygen-image-job:
  stage: build
  script:
    - docker build -f Dockerfile -t doxygen-run .
    - docker save doxygen-run | gzip > doxygen-run.tar.gz
  artifacts:
    paths:
      - doxygen-run.tar.gz
    expire_in: 3 hour
  only:
    - main

build-tests-image-job:
  stage: build
  script:
    - docker build -t run-tests .
    - docker save run-tests | gzip > run-tests.tar.gz
  artifacts:
    paths:
      - run-tests.tar.gz
    expire_in: 1 hour
  only:
    - main

run-tests-job:
  stage: test
  needs: ["build-tests-image-job"]
  script:
    - gunzip -c run-tests.tar.gz | docker load
    - docker run run-tests
  only:
    - main

generate-docs-job:
  stage: docs
  needs: ["build-doxygen-image-job"]
  script:
    - gunzip -c doxygen-run.tar.gz | docker load
    - docker run -v $(pwd)/DoxygenDocumentation:/app/DoxygenDocumentation doxygen-run
  artifacts:
    paths:
      - DoxygenDocumentation/
    expire_in: 10 days
  only:
    - main
